
PROmenu - Evaluation manual - Jupiter Software 1994                    Page 1


                                 JUPITER SOFTWARE

                            PROMENU - DOS MENU SYSTEM


                                     CONTENTS

                  GENERAL INFORMATION AND TUTORIAL

                  1     Introduction

                  2     Licence Agreement

                  3     The Programs

                  4     Installation

                  5     Keyboard/mouse control

                  6     On-line tutorial

                  7     Creating your first menu - tutorial


                  REFERENCE SECTION

                  8     Using PROMENU

                        8.1   Defaults
                        8.2   Screen protect mode
                        8.3   Timed events
                        8.4   Closing down system

                  9     EDITMENU

                        9.1   Editing a menu data file
                        9.2   Blank item lines and menus
                        9.3   Global menu options
                        9.4   Editing a menu option
                        9.5   Exit the edit routines

                  10    Action lines in detail

                  11    Networks and Enviroment variables



PROmenu - Evaluation manual - Jupiter Software 1994                    Page 2

                            PROMENU - DOS MENU SYSTEM

1     INTRODUCTION

      The PROmenu Dos menu system provides you with the capability of
      creating a hierarchical menu structure which is automatically
      displayed when you turn on the computer and from which you can select
      all your computer operations, be they programs or DOS utilities.

      The programs are not public domain and are not provided as freeware.
      PROmenu is a copyright software product written by Paul Brace and
      distributed by Jupiter Sofware.  This evaluation copy is provided for the
      purpose of allowing you to try the programs, and to discover how they can
      benefit you in both assisting you to run your own computer system more
      easily and protecting your data from unauthorized eyes.

      You are encouraged to copy the evaluation disk and distribute it
      freely among your friends and colleagues.  The only restriction is
      that the information on the evaluation disk must not be changed and
      all copyright notices must remain intact.

      After using the programs you will appreciate their benefit and, if
      you intend to use the programs after the evaluation period of 30 days,
      you should become a registered user, and pay the registration fee.

      The registration fee is currently set at 15 plus p&p site licence are
      available, please contact us for details.

                       Jupiter Software
                       63 Parkside
                       Wimbledon
                       London
                       SW19 5NL

                       Jupiter Software is an Author member of the ASP
                       (Association of Shareware Professionals)

                       Tel:    (+44) 081-947 4059
                       Fax:    (+44) 081-879 0090
                       BBS:    (+44) 081 947 7527

                       CompuServe:   100140,2134
                       Internet:     pbrace@cix.compulink.co.uk


PROmenu - Evaluation manual - Jupiter Software 1994                    Page 3

2     LICENCE AGREEMENT

      The program in this package is a proprietary product of Jupiter Software
      and is protected by Copyright Law.  Jupiter retains title to and ownership
      of the program.  You are licenced to use the program on the following
      terms and conditions:

      1 You may use the program for a period of 30 days, without paying a
        licence fee, for the purpose of evaluation.

      2 You may copy the installation disk and distribute it to your friends and
        colleagues for them to evaluate provided you comply with the following:

            a) No charge is made for providing the disk, other than a small
               handling charge to cover costs.
            b) You give them a copy of this notice.
            c) All files on the disk are copied and included on the distribution
               disk without alteration.
            d) All copyright notices and information remain intact.

      3 You may not decompile, disassemble, reverse engineer, or in any way
        modify the program code without the prior written consent of Jupiter.

      Jupiter warrants that the program will perform in substantial compliance
      with the documentation.  If you report a problem to Jupiter it will be
      examined and if necessary the program will be updated and a new copy
      issued to you.  You agree that the only remedy available to you will be
      the replacement of the program, if a program error was involved.

      DISCLAIMER - AGREEMENT

      Users of PROmenu must accept this disclaimer of warranty:

      "PROmenu is supplied as is.  The author disclaims all warranties,
      expressed or implied, including, without limitation, the warranties of
      merchantability and of fitness for any purpose, other than as outlined
      above.

      IN NO EVENT WILL JUPITER OR ANY OF ITS EMPLOYEES BE LIABLE TO YOU FOR
      DAMAGES, INCLUDING ANY LOSS OF PROFITS, LOST SAVINGS, OR OTHER INCIDENTAL
      OR CONSEQUENTIAL DAMAGES ARISING OUT OF YOUR USE OR INABILITY TO USE THE
      PROGRAM, EVEN IF JUPITER OR AN AUTHORIZED JUPITER REPRESENTATIVE HAS BEEN
      ADVISED OF THE POSSIBILITY OF SUCH DAMAGES, OR FOR ANY CLAIM BY ANY OTHER
      PARTY."

      TRADEMARKS

      PROmenu is a trademark of Jupiter Software.
      IBM is a registered trademark of International Business Machines
            Corporation.
      MS-DOS is a registered trademark of Microsoft Corporation.
      Other brand and product names are trademarks or registered trademarks of
            their respective holders.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 3a

                        ASP OMBUDSMAN STATEMENT

This program is produced by a member of the Association of Shareware
Professionals (ASP).  ASP wants to make sure that the shareware principle
works for you.  If you are unable to resolve a shareware-related problem with
an ASP member by contacting the member directly, ASP may be able to help.  The
ASP Ombudsman (OMB) can help you resolve a dispute or problem with an ASP
member, but does not provide technical support for members' products.  Please
write to the ASP Ombudsman at 545 Grover Road, Muskegon, MI 49442-9427 or send
a CompuServe message via CompuServe Mail to ASP Ombudsman 70007,3536.  The OMB
may be contacted by FAX by sending to the ASP FAX number: (616) 788-2765.  In
communication with the OMB please include a telephone and/or FAX number if
available.


                   _______
              ____|__     |                (R)
           --|       |    |-------------------
             |   ____|__  |  Association of
             |  |       |_|  Shareware
             |__|   o   |    Professionals
           -----|   |   |---------------------
                |___|___|    MEMBER


PROmenu - Evaluation manual - Jupiter Software 1994                    Page 4

3     THE PROGRAMS

      PROmenu is a DOS menu system which is based on the batch file language
      of DOS.  PROmenu uses Menu data files to store the batch commands
      required to run the Menu options.  It works by extracting, from the
      Menu data file, the commands necessary to run the option selected and
      storing these in a batch file called DOSMENU.BAT.  The batch file is
      then run executing the option chosen.  The last few instructions of
      the batch file reselect the drive and directory from which PROmenu was
      run and run PROmenu again thereby taking the user back to a menu
      rather than leaving him hanging in DOS.  This is a well-tried method
      of creating a friendly user interface to DOS and other programs are
      available to carry out the same task.  However, PROmenu has the
      following advantages:

      1)    Menu data file editing is carried out using a friendly user
            interface.  This is perhaps one of the most important, time saving,
            aspects of the programs.  As a user you do not have to remember how
            to structure the data file, or what codes or symbols to use to
            create a specific event. The data file edit program is
            straightforward and deals with the creation of the data file for
            you.

      2)    Any number of menus may be used.  Each menu data file can hold up
            to 10 menus with 9 options on each and it is possible to create a
            hierarchical menu structure utilizing an unlimited number of menu
            data files.

      3)    Any option from any menu may be password protected.

      4)    All the user has to do is type in the commands he would have used
            to run the routine from DOS, and these are stored in a data file.
            The system automatically, unless instructed not to, includes the
            instructions "ECHO OFF" and "CLS" at the beginning of the batch
            file so the user does not have to repeat these for each menu
            option.  In addition the instructions to switch back to the drive
            and sub-directory from which PROmenu was run, together with an
            instruction to run PROmenu again are automatically added to the end
            of the batch file, so again the user does not have to worry about
            ensuring that this is done.

      5)    All menu data files are encrypted and may only be changed using
            the EDITMENU program.  This gives added security to a computer
            system where it is required to direct the user activity in a

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 5

            particular way.  If EDITMENU is not present on the system, users
            cannot edit the data files.

      6)    A screen saving routine is included to prevent the menu image
            becoming burnt on the screen.  However, instead of becoming
            completely blank a small window is moved randomly about the screen
            thereby giving positive confirmation that the computer is switched
            on.  This reduces the risk that a computer will be accidentally
            left on overnight simply because the screen is totally blank.

      7)    Up to 5 timed events can be set for each menu data file.  When
            PROmenu is running it is constantly checking to see if it is time
            to run a timed event.  Each timed event can be set to run any
            option from any menu, and could be used for example:

            a)    To access an external service in the middle of the night
            b)    To carry out back-ups at fixed times
            c)    To run a communication package and put the computer into host
                  mode at a particular time.

            Many other uses will no doubt come to mind.

            As the batch file will automatically take the system back into a
            PROmenu menu after the routine is complete, it is possible to set
            any number of events to take place sequentially during the course
            of the day.

      8)    An advanced internal command set is available which allows the
            experienced user to set up interactive prompts for information
            from within PROmenu, which will then be passed to DOS.

      The first item above is perhaps the most important as you will not
      have to edit your menus very often.  It is possible that you might
      create a menu for your system, put the programs away, and not need
      to make any changes for a very long time.  In 12 months time coming
      back to the system and trying to work out how the menu structures
      work can, with some systems, be a time consuming and expensive
      exercise.  With our system you simply run EDITMENU and are guided
      through the process from that point on.  Within minutes you will have
      edited your menu no matter how long it is since you have used the
      system.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 6

4     INSTALLATION

      Installation is very simple and an automated, menu driven installation
      routine is provided on the installation disk.

      To install PROmenu on your hard disk, place the installation disk in your
      floppy drive, say A:, make A: the default by typing:

        A:      <return>

      and type

        Install <return>

      A menu will appear, displaying the following options:

      1     Install PROmenu on the hard disk
      2     Exit installation routines

      1   Install PROmenu on the hard disk

          Select this option first, by either pressing "1", or positioning the
          highlight bar over the option using the "Up" and "Down arrow" keys,
          and pressing <return>.

          On selecting the option the following prompt will appear:

          Routine to install PROmenu on your hard disk.
          Please select the letter which corresponds to the drive you wish to
          use.
          C: D: E: F: G: H: I: J:

          The highlight will initially be positioned over Drive C:.

          Position the highlight over the letter which represents the drive you
          wish to use and press <return>.  If, however, you are not sure which
          drive you wish to use, you may press Esc to abort the installation
          process and come back to it later.

          On selecting the drive letter, the system will create a directory
          called PROmenu on the hard disk and copy to it all the programmes and
          data files.  Various messages will appear on the screen as the process
          progresses and on completion the screen will clear and the following
          message will appear:

            Installation complete

          Pressing any key will return you to the installation menu.

      2   Exit installation routines

          Select this option by pressing "2", or positioning the highlight over
          the option and pressing <return>, to exit from the installation
          routine and return to DOS.  You will be warned that you have requested
          an exit to the operating system.  If you wish to return to the
          Installation Menu press Esc, otherwise press any other key and you
          will be returned to the DOS prompt.

          You have now completed the installation of PROmenu and the programmes
          are available for use.

      To install the program manually simply create the sub-directory, log on
      to it and copy all the files from the distribution diskette.  The key
      stokes required to install the programs on C: are as follows:

      From the C prompt type -

                  C:\         (return)
                  MD promenu  (return)
                  CD promenu  (return)
                  Copy A:*.*  (return)

      The above assumes that the distribution disk is present in Drive A:.

      For added security the program EDITMENU.EXE may be deleted as it does
      not have to be present when PROmenu is being used.

      To invoke PROmenu, once you have a menu system set up, make sure that
      the menu sub-directory is the default, and call the program by typing

                  C: \promenu (return)
                  Menu        (return)

      This runs the menu batch file which will run PROmenu, using the
      defaults (one of which is to use the DOSMENU.PRO data file), and on
      exit from PROmenu will run the DOS file called DOSMENU.BAT.  This is
      the batch file which is created by PROmenu based on the menu option
      chosen.

      To arrange for PROmenu to be run automatically when the computer is
      switched on include the instructions to change to the menu sub-
      directory and run the batch file called MENU as the last two
      instructions of the AUTOEXEC.BAT file.

      If you do not know how to edit the AUTOEXEC.BAT file please contact
      BBHW for further assistance.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 7

5     KEYBOARD/MOUSE CONTROL

      PROmenu can be run using either keyboard or mouse control.

      On start up the system will look to see if a mouse driver is installed
      and if present will turn on mouse control. If so, you will see a solid
      block in the centre of the screen which can be moved around using your
      mouse.

      You must therefore activate the driver which was supplied with your
      mouse BEFORE running PROmenu. See your mouse instruction book if you are
      not sure how to do this.

      KEYBOARD CONTROL

      PROmenu can be controlled from the keyboard even if the mouse is active.
      Whenever the system requires input you will see a flashing cursor on the
      screen at the position where the input will appear as you type it.  The
      system always knows the maximum length of acceptable input and it will
      display an input field of this length.

      During input of data the following keys are active:

      Left arrow   -    Move the cursor position back one character.  This
                        action is non destructive.

      Right arrow  -    Move the cursor one position forward.  The system will
                        not allow the cursor to move outside the entry field.

      Backspace    -    Insert mode  : Delete the character to the left of the
                                       cursor.
                        Overtype mode: Same as for left arrow.

      Delete key   -    Delete the character under the cursor.

      Insert key   -    Toggle insert mode - see below.

      ESC key      -    Exit from the current menu structure.

      F1-F10       -    Action as explained on screen at the time.

      As the system knows the length of the entry field it will automatically
      accept the entry if you fill the field,  eg one character for menu
      selection.  It is not necessary to press return.  If you wish to enter
      fewer characters than the maximum allowed, press return when your entry is
      complete.

      On entry to the system you will be placed in insert mode, represented by
      a half size flashing cursor. In this mode the backspace key is
      destructive and anything you type is inserted in the entry field, if the
      cursor is not at the end of your current entry. To switch to overtype
      mode press the insert key. In overtype mode the backspace key is non
      destructive and anything you type will overwrite existing text if not at
      the end of your current entry.

      Pressing the insert key toggles between insert and overtype mode.

      MOUSE CONTROL

      Throughout both PROmenu and EDITMENU mouse control is available.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 8


      Simply position the mouse over the option/key description required and
      press one of the mouse buttons.

      Selecting a menu option - position the mouse cursor anywhere on the line
      showing the option required and press a button.

      Menu keystrokes - When a menu is displayed certain keys may be used to
      show other menus and help. To select these with the mouse, position the
      mouse cursor over the description of the key and press a button.

      Menu interaction - On selecting an option the user may be asked to input
      data or select an item from a list.  In this mode a line of information
      is shown at the foot of the screen.  Pointing to this line and pressing a
      button will action the event described.  When offered a list, pointing to
      one of the items on the list and pressing a button will select that item.

      In edit menu more areas are active but the same principles apply - point
      and press, eg when asked for confirmation to delete or abandon, point to
      the Y or N on the screen and press a button.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 9

6 ON-LINE TUTORIAL

      Included on the distribution disk is an on-line tutorial which is
      accessed by typing TUTOR.

      The tutorial is a series of PROmenu menus and each option should be
      selected in turn.  Run the tutorial now and follow it through.  Change
      to the directory containing PROmenu eg

                  C:          (return)
                  CD \PROMENU (return)
      and type
                  TUTOR       (return)

      Select the first item from the menu, by pressing 1, and read the four
      screens of information. You will then be returned to PROmenu. Select the
      other items in the same way.

      On selecting 3 you will have to enter a password, which is "pass". Type
      this and press return to access the option.

      Selecting item 5 will pass control to the DOS utilties menu. You may
      select any of the options from the four menus in the structure, but be
      careful, they actually do what they say! Select option 5 from menu 1 of
      the DOS utilities, or press ESC, to return to the tutorial.

      Continue and select option 6 & 7 from this menu, then press "right arrow"
      to get to menu 2, and then select each of the options in turn.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 10

7     CREATING YOUR FIRST MENU - TUTORIAL

      We suggest that first you run the on-line tutorial and then follow the
      example set out in this section to help you generate your first menu
      system.

      When you run both PROmenu and EDITMENU they assume a series of defaults
      are to be used.  These defaults include the use of a menu data file
      called DOSMENU.PRO, and this is the file we will use to create our first
      menu.

      Make sure that you are in the directory which holds PROmenu by typing:

                  C:          (return)
                  CD \PROMENU (return)
      and type
                  EDITMENU

      The system will display a message indicating that it is creating a new
      menu structure.  This is because it is using the default file
      DOSMENU.PRO which does not exist. If the default file had already been
      generated it would have been loaded and the existing data offered for
      editing. We will see this when we reload this file for editing later in
      the session.

      You will now be presented with the EDITMENU main menu. Select option 1
      to "Edit menu file" and you will be presented with the menu selection
      screen, which will initially show menu 1 of 10.  At this stage the menu
      structure is empty, but it is all available to hold data.

      Let's start by creating an option to do a directory of your C: drive.

      First we want to tell PROmenu which menu item we want to hold this
      routine. Check that you still have menu 1 displayed, if not press the
      right or left arrow key until it is. Select item 1, either by pressing
      the "1" key, or by moving the highlight bar over item 1 using the up and
      down arrow keys, and press return.

      Whichever option you use will result in the Item edit screen being
      displayed.  This screen is split into three:

      *     Top     - showing details of the item name and password
      *     Middle  - containing the first 15 action lines
      *     Bottom  - showing the function key action

      The entry field will be over the item name.  Type in an appropriate name
      for the task in hand, say "To produce a directory of drive C:" and press
      return.  If you make a mistake use the left and right arrow keys to move
      the cursor and overtype.   When you are happy with your entry press
      return.

      When the system is first started you are placed in insert mode. This is
      indicated by a half size flashing cursor at the bottom of the character
      position. In this mode characters you type are inserted into text already
      on the screen. An alternative mode is "overtype mode". To switch to this
      mode press the Insert key. This mode is indicated by a line cursor at the
      bottom of the character. In this mode any characters you type will
      overwrite text already on the screen and the backspace key is non
      destructive. In both modes the cursor keys are non-destructive and the
      Delete key will delete the character immediately above the current cursor

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 11

      position.

      To switch back to overtype mode press Insert again.  Play around with
      these two modes typing and deleting text until you are happy with the
      concept.

      After entering the Item name the entry field will move on to the
      Password field. If you are not happy with the name you have typed in
      press the up arrow key and you will move back to the Name field.  You
      may now edit this and press return to move down again.

      At any of the fields on this screen you can press the up and down arrow
      keys to move up and down the records on the screen.  These keys, like
      the function keys also available,  explained below, will only be active
      if the cursor is positioned on the first character of the field.  Also
      note that the changes you have made are only accepted when you press
      return.  If you make a change, move the cursor to the first character
      and press up or down arrow, the changes will be lost.

      We will not enter a password for this item so press return with no
      entry.

      The entry field will have moved onto the first line of the action list.
      You will see at the top of the section that you are on the first page of
      the action list, there are 5 pages available to you, a total of 75
      lines.

      The action list is simply the list of keystrokes you would have entered
      to run the application from DOS.  In our example we would have first
      changed to the directory we wanted listing and then typed the command to
      list it, we do the same in the list. Type the following in for the first
      3 lines:

                  cd \
                  dir /w
                  pause

      There are a number of things to note:

      * It is not necessary to turn echo off and clear the screen, PROmenu
      does this for you.  Echo off is a batch command.  If you are not
      familiar with the DOS batch language we suggest that you refer to your
      DOS manual.  It is not vital that you know how to use the language but a
      few simple command, like echo, pause and cls can help you make the
      running of your menu options look more professional.

      * When PROmenu passes control back to DOS to run the option selected, the
      menu directory will be the default. If you wish to change this include a
      CD command in the action list.  In our case we are changing to the root
      directory.

      * dir/w does all the work

      * After carrying out the instruction it is a good idea to get the system
      to pause so that you can read the results.  Hence the inclusion of
      "pause" which will halt operations until a key is pressed.

      * It is not necessary to include any instructions to cause the system to
      return to PROmenu and redisplay the menu.  PROmenu will automatically
      re-run itself and display the menu from which the option was chosen, on

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 12

      completion of the called task.

      You have now entered your first selection so press Esc to return to the
      menu selection screen.

      The item you have just entered will appear next to 1 on the menu.  If
      you have made a mistake, select the item again by pressing "1" or moving
      the highlight and pressing return.  The Item edit screen will be
      displayed but this time all the information you have already entered
      will be offered for edit.  Move the entry field to the line to be
      changed and retype as required.  When you have finished press Esc to
      return to the Menu edit screen.

      We will now enter two more menu items.

      Select item 2 and enter the following, using the principles covered
      above:

            Name:       Check the hard disk for errors
            Password:   check
            Action:     cd \
                        chkdsk c:
                        pause

      Select item 3 and enter the following:

            Name:       Exit to operating system
            Password:
            Action:     cd \
                        echo Now in operating system
                        prompt $p$g
                        no return

      Item 2 will carry out a chkdsk of the hard disk and report any errors.
      Access to this routine is password protected and on selecting it you
      will be asked to enter the password.  To gain entry the password must
      match - it is case sensitive.

      Item 3 returns the user to DOS.  We have included a new concept in this
      entry - the command "no return".  This line is interpreted by PROmenu as
      an instruction not to return to PROmenu after completing the selected
      menu routine.  After running the echo and setting the prompt to show
      both the drive and directory (this is what prompt $p$g does) the system
      will stay in DOS.

      It is important to have an option to exit to the operating system in the
      menu structure if you wish the user to be able to work the computer
      outside the PROmenu structure.

      You should now have the Edit menu screen displayed showing menu 1 with
      the three items on it.  The final task to make the menu complete is to
      add a heading to the menu.  Press F3 and a window will open requesting
      you to enter a heading.  Enter, say:

            MY FIRST MENU

      As the heading and press return, the window will close and the heading
      will appear at the top of the screen.

      You have now completed you first menu.  To save it to disk, press Esc and

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 13

      you will be returned to the Main menu.  Select "4 Save changes" and the
      file will be written to disk and you will be returned to the DOS prompt.

      Now run the menu by typing:

            MENU

      The system will activate using the default menu you have just generated.
      The menu will be displayed as "Menu 1 of 1" as there is only one active
      menu in the structure.

      Select item 1 by pressing "1" or positioning the highlight bar and
      pressing return.  A directory will appear.  After reading the directory
      press a key and the system will return to your menu.

      Select option 2 and a window will open asking for a password.  Try
      entering an incorrect password and you will see that the help screen is
      displayed to reflect the fact that the password has not been accepted.
      Press any key and you are returned to the menu.  Try again, this time
      entering the correct password and the routine will run a chkdsk.
      Pressing any key will again return you to your menu.

      Finally select option 3 and you will be returned to DOS.

      ADDING A SECOND MENU

      We will now edit the menu data file, add a second menu and look at some
      of the more sophisticated areas of PROmenu.

      Change to the menu directory and type:

            EDITMENU

      Select "1 Edit menu file" from the main menu.

      This time you are offered the existing menu structure to edit.  We will
      leave menu 1 alone and add a second menu to the system.  Press right
      arrow and menu 2 of 10 will be displayed.

      Start this time by entering the menu heading.  Press F3 and enter:

            EXTENDED OPTIONS

      Press return and the heading will be shown at the top of the screen.
      Now select item 1 and enter the following:

            Name:       Directory of a selected drive
            Password:
            Action:     .print We will now produce a directory of the
                        .print drive you select.
                        .select A://B://C:
                        dir %1\ /W/P
                        pause

      We have introduced a new concept and two commands.  The concept is that
      of carrying out user interaction within PROmenu before the batch file is
      executed and the commands are two of the dot commands ".print" and
      ".select"

      When you include dot commands in an action list they are interpreted by

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 14

      PROmenu and acted on before the batch file is written and executed.  In
      the above example PROmenu will print on the display the two message
      lines and then request the user to select from the option list.  The
      list entered after the ".select" command is made up of alternatives
      which are acceptable input, each is separated by two /s.  On running the
      option the system will display the alternatives and the user may select
      from them by moving the highlight bar and pressing return.  The options
      are presented side by side so that the highlight bar is moved with the
      left and right arrow keys.  If the user presses Esc at this point the
      system will return to the menu without running the routine.

      The selection it is stored as parameter %1 for use by the batch file.
      If a second "select" line were used this would be stored as %2, and so
      on.

      It is important that the instruction to create the parameter (.select
      ... in our example) precedes any line which uses it (dir %1....).

      Now enter item 2 as follows:

            Name:       Copy a file
            Password:
            Action:     .print Routine to copy a given file to another name.
                        .print Either on the same disk or, by including a
                        .print path onto another disk or directory.
                        .input Enter file to be copied:
                        .input Enter file to copy to:
                        copy %1 %2
                        .help This routine allows you to make a copy of a file
                        .help on disk.
                        .help You will first be asked to enter the name of the
                        .help file to copy and then the file to copy to.
                        .help You may include paths in the file name.

      In this option we have introduced two new dot commands, ".input" and
      ".help".

      You will no doubt already have worked out that ".input" allows you to
      enter a string as opposed to selecting from a list.  The prompt which
      follows the input command will be displayed and then the system will
      wait for the user to enter his data.  As with select the first entry is
      assigned to %1 the second to %2 etc.  Input and select commands may be
      mixed in a single action list and they are assigned in the order they
      appear.

      ".help" allows you to enter up to 10 help lines which will be displayed
      to the user if he presses the help key while the highlight is over the
      menu item.  The help commands must appear together but they may be
      anywhere on the first page of the action list.  This brings out an
      important point.  It does not matter in what order the dot commands and
      other data appear in the list.  All dot commands will be actioned first
      before the batch file is written and executed.  As you would expect the
      dot commands are not written out with the batch file.

      Four other dot commands are available - ".pause" which causes the
      system to pause until a key is pressed, ".menu" and ".back" which allow
      you to load another menu structure and ".clear" which clears the PROmenu
      dialogue screen.  The pause command can be very useful as when it is
      encountered it gives the user an opportunity to press Esc to abort the
      selected process.  You can therefore ask "Are you sure" type questions
      from within PROmenu.  These commands are used in the TUTOR and

 PROmenu - Evaluation manual - Jupiter Software 1994                  Page 15

      DOS menus, have a look at them and see the way they have been applied.
      Both menu structures may be accessed from menu 2 of the on-line
      tutorial.

      After entering the above press Esc and save the changes.

      Now run the menu again by typing:

            MENU

      This time you will see that your original menu is displayed with "Menu 1
      of 2" shown top right.  Press the right arrow key to see your menu 2.

      Position the highlight over item 2 and press F1, you will see your help
      screen.  Press any key to remove the window and select item 1.  The
      message will be displayed and the alternatives offered for your
      selection.  Use the arrow keys to move the highlight over "C:" and press
      return.  You will be rewarded with a directory of C:.  Press any key to
      return to your menu.  Note that the system automatically returns to the
      menu from which the option was chosen, 2 in this case.

      Select item 2 and you will be asked to enter a file name.  Enter the
      name and press return. (Esc will abort the routine).  Enter the name of
      the file to be copied to and the copy will be carried out.

      Return to menu 1 by pressing left arrow, and select the option to exit
      to DOS.

      Congratulations!  You have now created your first menu and mastered all
      you need to know to create a sophisticated front end menu system.

      The following sections cover how you can use your chosen menu file
      names, change the colours used on screen, set timed events to take place
      and they act as a reference to both PROmenu and EDITmenu.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 16

8 USING PROMENU

      Once PROmenu has been invoked, and provided valid data is contained in
      the data file in use, the first menu will be presented to you.

      The menu screen is split into three parts.  The top contains the name
      of the current menu displayed, the middle contains the menu number and
      up to 9 options, and the third part at the foot shows the current day,
      date and time, together with details of the key strokes available.

      As mentioned above each menu data file may contain up to 10 menus and
      to change to the next menu, menu 2 initially, press the right arrow.
      If menu 2 is active it will be displayed, if not menu 1 will remain
      on the screen.  Pressing right arrow will move on to the menu
      subsequent to that displayed until the last menu in the current data
      file is reached.  Pressing right arrow at the last menu will simply
      leave that menu displayed on the screen.

      All key strokes are explained on the screen and may be selected by
      moving the mouse pointer to the explanation and clicking a button.

      To move to the preceding menu from that display press the left arrow.
      Pressing left arrow at the first menu in the file will have no affect
      and the first menu will continue to be displayed.

      With any menu displayed pressing Esc will return the system to the
      first menu in the data file.

      There are three methods of selecting an option from the menu which is
      currently displayed:

      1)    Move the highlighted bar to the option required by pressing the
            up and down arrow keys, and then press either return or the space
            bar.

      2)    Simply press the number corresponding to the menu item.  Either
            the number pad, or the number keys at the top of the keyboard may
            be used.

      3)    Position the mouse pointer anywhere on the item line and press a
            button.

      If you accidentally press a key which is not acceptable PROmenu
      will display the help screen which contains a brief description
      of the key strokes which are available to you.

      Some menu options may have help lines included.  Pressing F10 with the
      highlight over the appropriate option will display the help lines, if
      present.

      If the option selected is password protected a window will be opened
      and you will be asked for the password.  Enter the password and the
      system will proceed.  If the password entered is not valid it will be
      rejected and the help screen displayed to indicate this fact.  At this
      point pressing any key will return you to the original menu.

      Some menu options may load a sub-menu structure.  If you are in a
      sub-menu there should be an option which will return you to the previous
      menu structure.  You may select this option in the normal way, or press
      the ESC key at any point in the sub-menu to return to the calling menu.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 17


      On selecting a menu option the appropriate commands will be written
      out to the batch file called DOSMENU.BAT.  In most circumstances these
      will be preceded by an instruction to turn echo off and clear the
      screen and followed by instructions to switch back to the drive and
      sub-directory containing PROmenu and run PROmenu again.  Both the
      clear screen and return to PROmenu instructions may be suppressed,
      details of how to do this are contained in the section covering
      EDITMENU.

      If the generator of the menu has included action lines to display
      prompts to the user and accept input, these will be displayed and
      requested before the batch file is written and run.  There are two types
      of instructions which request the user to input data, a "select" command
      and an "input" command.

      "Select" command

      When this is used the user is offered a list of alternatives from which
      he may chose.  The highlight bar will initially be positioned over the
      first item and may be moved by pressing the left and right arrow keys.
      Place the highlight over the item to be selected and press return.

      "Input" command

      With this the user is invited to enter a string of up to 50 characters.
      The normal rules are followed, ie overtyping, insert mode, moving the
      cursor etc.  Type in the information and press return.

      When the system has requested data, or has paused for the user to read a
      message displayed by the option, Esc can be pressed to abort the routine.

      After the batch file has been generated it will be executed and the
      selected option run.  When you have finished with the program or
      routine chosen, exit in the normal way and, in most cases, you will
      be returned to the PROmenu system to the same menu from which the
      option was chosen.  If you are not returned to the PROmenu system
      this will have been deliberately engineered and you should have
      instructions on how to proceed from there from the person who
      generated the system.

8.1   Defaults

      Calling PROmenu with no command line options causes it to utilize the
      following defaults;

      a)    Batch file used to run PROmenu and the option selected - MENU.BAT
      b)    Menu data file DOSMENU.PRO
      c)    Batch file to run applications - DOSMENU.BAT
      d)    Normal text attribute - Mono screen 7 - Colour screen 23
      e)    Window text attribute - Mono screen 112 - Colour screen 48
      f)    Entry line text attribute - Mono screen 1 - Colour screen 7
      g)    Start with Menu 1 displayed
      h)    Start with item 1 highlighted

      If it is required to run PROmenu with values different from the
      default they may be set by adding command line options after PROmenu
      in the batch file MENU.BAT.

      Assuming that you wish to utilize a data file called MYFILE.PRO and

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 18

      would like to stop the windows being shown with a solid background,
      the line would look as follows:

                  PROmenu /M:MYFILE.PRO /W:7

      Command line options are separated by a space and each option is an
      oblique followed by a single letter, either in upper or lower case, a
      colon and the value to be used in place of the default.  In the above
      example M stands for Menu file and is followed by the new Menu file name,
      W stands for window text and is followed by the attribute to be used.
      Command line options may be presented in any order and if any option is
      invalid an error message will be given and the program will not run.

      The eight command line options are described below:

            M - Use a different menu file.

            The option should be typed as /M:xxx.xxx with no spaces.  The M
            tells the system to use a new menu file and the xxx's represent the
            full file name, with path if it does not reside in the default sub-
            directory.  If no file extension is given ".PRO" is used as a
            default.

            B - Use a different menu batch file.

            As provided PROmenu assumes that a batch file called MENU.BAT is
            used to call PROmenu and run the options selected.  The batch file
            contains the following two lines:

                        PROmenu %1 %2 %3 %4 %5 %6 %7
                        DOSMENU

            If for some reason you do not wish to use the file called MENU.BAT
            for this purpose but would like to use something else, eg
            ITEMS.BAT, then you would use the option /B:xxx.  In our example we
            would have used BITEMS, and the ITEMS.BAT batch file would have
            contained the following:

                        PROmenu /B:ITEMS %1 %2 %3 %4 %5 %6 %7
                        DOSMENU

            U - Use a different User batch file to run application

            As a default PROmenu will generate a batch file called DOSMENU
            which it will invoke to run the chosen application.  There may be
            certain circumstances, eg network environment, where it is
            preferable to call the file by another name.  For a network you may
            wish each user to have a different set of batch files.

            You may change the name of the file by adding a command line option
            of
                         /U:FILENAME

            If you use this option you MUST also change the batch file used to
            run the system (eg MENU.BAT) to call the user batch file which
            will be generated.  Where /U:FILENAME has been used the batch file
            should read:


PROmenu - Evaluation manual - Jupiter Software 1994                    Page 19

                         PROmenu %1 %2 %3 %4 %5 %6 %7
                         FILENAME

            N - Different attribute for normal text

            Placing an option /N:999 on the command line will cause the system
            to use the number typed as 999 as the attribute for normal text.
            You can experiment to see what results this produces on your
            monitor.

            W - option for windowed text

            As for the normal text option placing /W:999 on the command line,
            where 999 is a number, will cause PROMENU to use that attribute
            for all text displayed in the window.

            E - Entry line attribute

            Placing the option /E:999 in the command line will cause the number
            following the E to be used as the attribute for displaying text at
            the entry field where the cursor is currently sitting.

            The attribute, represented by 999 above, can be any number from 1
            to 255.  If a number other than one within the range is used the
            option will be rejected and PROmenu will not run.

            S - Start at menu number

            Including /S:99 in the command line forces PROmenu to start with
            menu number 99 displayed.  99 is a number up to 10.

            When you run an option from PROmenu it stores the menu number in
            the batch file generated so that you are returned you to the Menu
            from which the option was selected.

            I - Start with item number highlighted

            Including /I:9 in the command line forces PROmenu to start with the
            highlight bar over the given item. 9 is a number from 1 to 9.

            When you run an option from PROmenu it stores the item number in
            the batch file so that it may return you to exactly the same point
            when the routine is complete.

            T - Timeout for screen save

            The option /T:999 in the command line causes PROmenu to change the
            timeout for activating the screen save facility.  999 is the number
            of seconds to use and can range from 1 to 999.

      The command line options described above may also be used when
      invoking EDITMENU as described below.

8.2   Screen protect mode

      To avoid the image of the menu becoming burnt on the screen PROmenu
      will switch to screen protect mode if no key is pressed for a period
      of time.  The default it 2 minutes, but this may be changed as described
      above.

      In the screen protect mode a window is displayed at a random position
      and this window will be regularly moved about the screen.  Pressing
      any key will return the system to the menu which was displayed when
      the screen protect mode came into operation.

8.3   Timed events

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 20


      Each data file may have up to 5 timed events recorded.  Each of these
      5 events can invoke any option from any menu at a specified time
      during the day.

      When PROmenu is in screen protect mode it is constantly monitoring
      the time and the 5 scheduled events.  As soon as the time for an event
      has come PROmenu will run the option from the menu as though it had
      been selected from the keyboard.

      If the action list recorded for that option results in the system
      returning to PROmenu it will again enter screen protect mode and
      monitor for the next timed event to take place.

      On entry to PROmenu the system looks at the timed event schedule and
      if the time has already passed for any event, flags the event as not
      being active for the current day.  However, if the computer is left
      on over midnight all events are released so that they will be run as
      and when their time is reached.  By this means one can leave the
      computer switched on overnight and have routines automatically run in
      the early hours of the morning.

      Although each menu can only have 5 timed events recorded it is of
      course possible for the last event to call a new menu which in turn
      can have 5 timed events.  There is therefore, in theory, no limit to
      the number of timed events you can set to take place each day.

8.4   Closing down system

      Although there is no hard and fast rule for closing down the PROmenu
      system, (no harm will be done if the computer is switched off whilst
      PROmenu is running), it is good practice to park the hard disks each
      night before turning the system off.  We therefore recommend that the
      last option of the first menu is to close down the system.  This
      option should carry out whatever procedures are required to shut down
      the user at the end of the day, eg Log off the network if appropriate,
      park the heads and invite the user to disconnect the power.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 21

9     EDITMENU

      EDITMENU is the program which allows you to create and edit menu data
      files for use in PROmenu.  All editing has to be carried out using
      this program as the files are encrypted on disk and cannot therefore
      be changed by a text editor.  The purpose of encrypting the files is
      to ensure that passwords are kept secret and that the routines for
      calling various programs are not made known to unauthorized eyes.
      A further measure of security could be to hide the sub-directory in
      which PROmenu is placed.

      To run EDITMENU, change the default directory to that containing the
      data files to be edited and type the program name from the DOS prompt.
      If no command line parameters are given the system will look for, and
      load, the default data file called DOSMENU.PRO.  If the data file does
      not exist it will inform you that it is creating a new data file
      structure and offer you a blank menu system to be edited.  On exiting
      EDITMENU the new menu structure will be saved with the default file
      named DOSMENU.PRO.

      The same command line options may be used when calling EDITMENU as
      are available when calling PROmenu as follows:

      /M:xxxxx    This informs EDITMENU to use the menu data file called
                  xxx.xxx rather than the default menu data file of
                  DOSMENU.PRO.  If no file extension is given ".PRO" is used
                  as a default.

      /B:xxxxx    Change the name of the default batch file used to
      /S:99       invoke PROmenu and start at a specific menu/item.  They
      /I:9        have no practical effect when running this program.

      /N:999      The N option informs the system to use the number
                  following the letter as the attribute for normal
                  text.

      /W:999      W sets the attribute for window text to the number
                  following the W

      /E:999      This option sets the entry line attribute to that
                  given.

      /T:999      Change the timeout.

      999 in the above parameters represents a number from 1 to 255 to be
      used for the text attribute.

      When EDITMENU is run the system will either load the default or chosen
      menu file from disk or will inform you that it is creating a new menu
      structure.  An initial Main Menu is then displayed which gives 4
      options:

                        1  Edit menu file
                        2  Clear menu file
                        3  Abandon changes
                        4  Save changes

      1)    Edit menu file

            Selecting this option will take the system into data file edit
            mode which is fully described below.


PROmenu - Evaluation manual - Jupiter Software 1994                    Page 22

      2)    Clear menu file

            Selecting option 2 will cause the edit menu program to clear the
            data file structure which has been loaded from disk.  On selecting
            the option the programs will display the following message -

                        Routine to clear menu
                        This action will wipe out existing data
                        Are you sure (Y/N)

            If you wish to continue to delete the structure currently held in
            memory press Y otherwise pressing N will cause the structure to be
            left intact.

      3)    Abandon changes

            Selecting this option will exit the EDITMENU program without saving
            the changes you have made in the current run.  Select the option
            by pressing 3 and the system will produce the following prompt -

                        Abandon changes made in current session
                        Are you sure (Y/N)

            Pressing Y will cause the program to return to DOS without saving
            the changes while pressing N will return the system to the edit
            menu display.

      4)    Save changes

            Selecting this option, by pressing 4, will cause the EDITMENU
            program to save the menu data file, either under the default name
            of DOSMENU.PRO, or the file name given in the command line when
            edit menu was called, and the system will exit to DOS.

9.1   Editing a menu data file

      To create, or change, the menu data file select option 1 "Edit menu
      file" from the Main menu.  The first menu stored in the file structure
      will be displayed, with the menu name at the top of the screen, the
      menu number top right and menu options in the centre.  Below the menu
      options will be displayed the following prompt -

            Esc Exit - F3 Menu Heading - F4 Timed execution
            F5 Insert option - F6 Delete option - F7 Insert menu - F8 Delete
                                                                      menu
            Left/Right arrow previous/next menu - F1 Help
            Followed by a line showing the current day, date and time.

      It is possible to scroll through the menus by pressing the left and
      right arrow keys.  Pressing the right arrow will advance to the
      following menu while pressing left arrow will display the previous
      menu to that currently displayed.  If left arrow is pressed when menu
      1 is displayed menu 10 will be shown and if right arrow is pressed
      when menu 10 is displayed menu 1 will be shown.  Menus will be
      displayed whether or not they currently contain any data allowing you
      to create a new menu where one did not exist before.

      Any option from the menu displayed may be chosen by positioning the
      highlighted bar and pressing return or space, or by pressing the
      number key corresponding to the option number.  Details relating to

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 23

      that particular option will be displayed and can be edited.

      Pressing F10 will display the user defined help screen for the option
      highlighted.  If no help has been defined an appropriate message is
      given.

9.2   Important note - Blank item lines and menus

      If you wish to separate items on the menu screen leave blank item lines
      where you wish the gap to appear.  For example, in menu 2 of tutor item
      lines 7 & 8 are blank an item 9 is "Return to DOS".  When this menu is
      displayed a two line gap is left and item 9 is renumbered 7 so that the
      items run consecutively.

      When PROmenu loads a menu file and offers it for options to be
      selected, it assumes that the first blank menu represents the end of
      the data file and will only offer for selection menus preceding the
      first blank menu in the file.  It is therefore important, if you wish
      all menus to be offered to the user, not to leave a blank menu in the
      middle of the file.  However, the feature can be used to good effect
      by storing in later menus options which can automatically be run from
      the timed execution records, but which are never displayed to the user
      for selection.

9.3   Global menu options

      With any menu displayed it is possible to carry out the following:

      a)    Return to the Main Menu - Press Esc
      b)    Edit the menu heading - Press F3
      c)    Edit the timed execution records - Press F4
      d)    Insert an option in the menu currently displayed - Press F5
      e)    Delete an option from the current menu displayed - Press F6
      f)    Insert a new menu in the structure - Press F7
      g)    Delete the currently displayed menu from the structure - Press
              F8

      a)    Esc to exit

            When any menu is displayed pressing Esc will return the system to
            the Main Menu display from which the changes made can be saved or
            abandoned.  If you accidentally return to this menu, selecting 1
            will return you to the menu edit routines.

      b)    Edit the Menu Heading

            To edit or enter the heading currently stored for the menu
            displayed, press F3.  A window will be opened in which will be
            displayed the current menu heading.  The menu heading may now be
            either typed or edited and when accepted, by pressing return, the
            window will be closed and the menu will be redisplayed.

      c)    F4 timed execution

            It is possible to set up to 5 menu options from each data file
            structure to be executed automatically at pre-determined times.
            Pressing F4 when any menu is displayed will cause a window to be
            opened in which will be listed the timed execution records as
            currently stored.  The entry field will be positioned over the
            menu number of the first record which may be changed, or accepted

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 24

            by pressing return.  Type in the menu number from which the option
            is going to be run and the system will move the entry field to the
            option number.  Type the option number to be run, or press return
            if it is not to be changed, and the entry field will move to the
            hours column.  Type in the hour, in 24 hour format at which the
            option is to be run and you will be invited to enter or edit the
            minutes to complete the time.

            After entering the minutes the system will allow the second item
            to be entered or edited in the same way.  Pressing up and down
            arrow at any time will cause the system to move to the previous
            or next timed execution item while pressing Esc will return the
            system to the menu display from which the timed execution window
            was called.

      d)    F5 insert option

            This facility allows you to insert a new menu option within the
            menu which is currently displayed.

            Pressing F5 will cause a window to be opened which will invite you
            to enter -

                        Item number to insert.

            Enter the appropriate item number from 1 to 9, if you do not wish
            to proceed pressing Esc will exit the routine without any action.
            On entry of an item number the system will move the current options
            stored for that item and all subsequent options down the menu to
            make space for a new item to be inserted.  The window will
            disappear and you will be returned to the menu in question.

      e)    F6 delete option

            This option allows you to remove an item from the menu and all
            subsequent items will be raised to fill the gap which is created.

            Press F6 when the menu from which the option is to be deleted is
            displayed and the system will open up a window and invite you to
            enter -

                        Item number to DELETE

            Pressing Esc will exit the option without any action, while entering
            an item number will cause that item to be deleted from the menu
            currently displayed and all subsequent item numbers to be moved up
            one to fill the gap created.

            After an item number is entered the window will disappear and the
            menu will be redisplayed.

      f)    F7 insert menu

            Pressing F7 will cause the system, after confirmation, to insert
            a menu in the position occupied by the menu which is currently
            displayed.  The currently displayed menu, and all subsequent menus
            will be moved forward one to make space for the new menu.  Care
            should be taken as menu 10, if active, will be lost.

            Pressing F7 will cause a window to be opened and the following

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 25

            prompt displayed -

                        Confirm insert new menu 9 (Y/N)

            Where 9 will be replaced by the number of the menu to be inserted.
            Pressing Esc or N will exit from the window without any action while
            pressing Y will cause a blank menu to be inserted and displayed for
            edit.

      g)    F8 delete menu

            This option allows you to remove the menu which is currently
            displayed when F8 is pressed, all subsequent menus will be moved
            back one menu slot and menu 10 will be blanked.

            Pressing F8 will cause a window to be opened and the following
            prompt displayed -

                        Confirm DELETE menu 9 (Y/N)

            Where 9 will be replaced with the menu number which is currently
            displayed.

            Pressing Esc or N will exit the window without any action while
            pressing Y will cause the menu which is currently displayed to be
            deleted and the subsequent menus to be moved back one menu number.

9.4   Editing a menu option

      To edit a menu option select the item with the highlight or, press
      the number corresponding to the option while the appropriate menu is
      displayed.  On selection a window will be opened, which is divided in
      three.

      The top section of the window contains the option name and password,
      the middle section the 15 lines of batch file instruction which will
      be used to call the option, while the third section contains the
      following prompt -

                  Esc exit - F5 Insert  F6 Delete action line

9.4.1 Menu option name

      The entry field will be positioned over the menu option name.  The
      current menu option name can be edited, or entered by straight typing.

      The menu option name can be up to 60 characters long.

9.4.2 Password

      After entering the menu option name the entry line will move on to
      the password field.  If the password is left blank the menu option
      will be unprotected and no password will be requested when the option
      is selected within PROmenu.  If a password is required simply enter
      the password at this point, up to 10 characters long.

      If a password has been entered for any menu option it will be
      requested when the option is selected through PROmenu.  An exact match
      must exist for the password to be accepted and the option to be run.
      The password is therefore case sensitive.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 26


9.4.3 Action lines

      After entering the password the entry line will jump down to the first
      action line within the middle section of the screen.  Action lines are
      the commands which are required to run the option, and up to 75 lines
      may be entered, each 70 characters long, for each option on the menu.
      The action lines are displayed in blocks of 15, described as pages 1 to
      5.  Initially you will offered the first 15 lines, on page 1, for
      editing.  If you move the entry field down to the last line displayed
      and press enter or down arrow, the next 15 lines will be shown.
      Similarly pressing up arrow when the entry bar is on the first line
      displayed will cause the previous 15 lines to be shown.  Pressing up
      arrow when on the first line of page 1 will move the entry field up to
      the password.

      Simply enter here the commands you would have typed in DOS to run the
      routine.  (See section 9 for a full explanation of the commands
      available to you).

      It is not necessary to enter the commands to "ECHO OFF" and clear the
      screen as these will be inserted automatically at the beginning of the
      batch file, or to enter the commands to return to the PROmenu system
      after the option has been run, as these are also added by PROmenu.

      If, however, you do not wish the system to issue an echo off and clear
      screen at the beginning of the file simply enter "No Clear" as the
      first action line, and if you do not wish the system to return to the
      PROmenu system after the option has been completed, enter "No Return"
      as the last action line in the list.  This can be used, for example,
      to effect an exit to DOS as an option from a menu.

      For examples of how the menu action lines are constructed look at the
      two menu data files provided with this evaluation set.  The file
      TUTOR.PRO mainly contains text printing, which explains the basic
      operation of PROmenu, while the file DOS.PRO (which is called from
      option 5 of menu 1 of the tutor menu) is a menu data file containing
      a number of commonly used DOS utilities.  This shows how programs and
      DOS commands can be called from within PROmenu.  It also contains an
      option to return to the main menu, demonstrating how a hierarchical
      menu structure can be created.

      Enter the first line to be entered in the batch file, and press return
      which will cause the entry field to move on to the next line.
      Pressing down and up arrow will cause the entry field to move up and
      down the action lines.  To insert a new action line, at the position
      where the entry field, is currently displayed, press F6 and the
      current action line under the entry field and subsequent lines will
      be moved forwards to open up a space for a new action line to be
      entered.  Conversely pressing F6 will delete the action line which is
      currently highlighted as the entry line and pull all subsequent action
      lines back to fill up the gap created.

      Pressing Esc when either the option name, password or action section
      is being edited will close the window and return the system to the
      menu from which the window was called.

      When the Action lines are stored all totally blank lines are removed to
      keep the data as compact as possible.


PROmenu - Evaluation manual - Jupiter Software 1994                    Page 27

      Note: For users of DOS 3 and above

      If you wish to run an existing batch file from within the PROmenu
      generated batch file use an action line of

                  CALL BATCH

      where batch is the name of the file.

      This will run the external batch file, and control will return to the
      PROmenu batch file on completion.  In this way the system will
      automatically return to PROmenu.

9.5   Exit the edit routines

      To exit the edit routines, if a menu from the data file is displayed,
      press Esc and the system will return to the Main Menu.

      If you wish to save the changes made in the current run press 4 and
      the file will be written back to disk and you will be returned to the
      DOS prompt.  If, however, you do not wish to save the changes you have
      made, press 3 and the system will abandon the changes, after asking
      you to confirm that this is the action you require.

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 28

10    ACTION LINES IN DETAIL

      As we have indicated above, the action lines represent the DOS commands
      which will be issued to run the application chosen from the menu.  It
      is also possible to include "dot" commands which PROmenu will execute
      prior to running the application.  All lines starting with a "." are
      interpreted as internal commands and are not written out to the batch
      file.  If therefore you start a line with a "." but do not follow it
      with a valid command it will be treated as a line of comment entered
      purely for narrating your menu.

      If the first line is "no clear" and/or the last line is "no return"
      these are also treated as internal commands, see below.  All other
      lines are assumed to be batch file/DOS commands and will be written out
      to the batch file created to run the routine. If any line so written is
      not a valid command an error will be reported by DOS. The error message
      will depend on the problem encountered. If the error is a report and the
      batch file continues, eg Bad Command, the system will eventually return
      to PROmenu if that was the original action which would have been
      followed. If it causes the display of "Abort, Retry or Ignore" the
      system will only return to PROmenu if your response causes the batch
      file to continue running.

      Set out below is a summary of the Batch language of DOS 3.3.  For a
      detailed review of what is available on your computer see your DOS
      manual.

      *     CALL - Calls one batch file from another without ending itself.
            When the called batch file terminates control will return to the
            batch file which called it.

      *     ECHO - Echo followed by a message causes the message to be printed
            on the screen.

      *     ECHO OFF - You will normally run batch files with echo off.  This
            suppresses the display of the batch file lines as they are
            executed.

      *     ECHO ON - Causes batch file lines to be displayed as they are
            executed.

      *     FOR - Allows the creation of loops within a batch file to cause a
            series of instructions to be repeated a fixed number of times each
            time with the control variable set to a different value.

      *     GOTO - Process commands starting with the line after the specified
            label. See below for how to create a label line. Used in
            conjunction with IF creates conditional jumps in the batch file.

      *     IF - Performs a command based on a condition.  You can use IF to
            compare two strings, test for the existence of a file or test to
            see if the last action terminated in an error.  (examples of the
            use if the last are included on menu 4 of the DOS utilities.)

      *     PAUSE - Suspends execution of a batch file until a key is pressed.

      *     REM - Used to document your batch file (may be used in place of ".
            comment....".

      *     SHIFT - Lets you change the position of replaceable parameters in

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 29

            batch file processing.  ie %1 becomes %2, %2 %3 etc.  Allows access
            to parameters %11 and on which would not otherwise be available to
            you.

      *     : - The label sign.  Follow the : with a name which becomes a
            label that you can GOTO.

      There are ten commands, internal to PROmenu, available to you to
      control the operation of the menu program.  These commands are executed
      by PROmenu and not written out to the batch file.  They may appear
      anywhere in the list of action lines, unless otherwise stated, and will
      be actioned before the batch file is executed.

      The commands available are as follows:

      *     NO CLEAR - On creating the batch file to run the routine PROmenu
            will normally place:
                        ECHO OFF
                        CLS
            at the beginning of the file.  If you wish to suppress this make
            the first line of the action list read "no clear".  If this is
            placed anywhere else it will be ignored.

      *     NO RETURN - On creating the batch PROmenu will normally place:
                        C:
                        CD \MENU
                        MENU MDOSMENU.PRO S2 I3
            at the end of the file.  the C:, MENU, M, S & I parameters will be
            replaced with those appropriate to your system.  This causes the
            system to return to PROmenu after the routine has been executed.
            If you don't want this to happen, place "no return" at the end of
            the action list.  If it is included anywhere else in the file it
            will be ignored.  This can be used to effect an exit to the
            operating system from a menu option.

      *     .HELP - You may include help lines on the FIRST page of action
            lines.  Up to 10 help lines may be included in each menu option.
            These lines are ignored when the option is run, but are used to
            create a user generated help screen which the operator can call
            upon at any time.  When the highlight bar is over an option
            pressing F1 will open a window containing the help lines.  If no
            help lines are present an appropriate message will be given.

            The help screen can be seen from within the EDITMENU program so
            you can see how your screen will look as soon as you have entered
            the lines, allowing you to immediately make changes if it is not
            as you would like it.

            The final restriction is that the help lines must appear on
            consecutive lines as only the first group found will be used.

      *     .CLEAR - This causes the PROmenu dialogue screen to clear and
            position the next line displayed at the top of the window.

      *     .PRINT - This command causes whatever follows it on the same line
            to be printed to the screen as a user prompt.

      *     .PAUSE - Causes the system to suspend operations until the user
            presses a key.  If the user presses Esc PROmenu will suspend action
            on the chosen option and return to the menu.  Whatever appears on
            the line after the command will be printed to the screen as for
            .PRINT.


PROmenu - Evaluation manual - Jupiter Software 1994                    Page 30

            .PAUSE and .PRINT can be used together to make sure that the user
            really wants to run the option chosen, eg

                  .PRINT This routine will delete any data which is currently
                  .PRINT held on the floppy disk.
                  .PRINT
                  .PRINT Press Esc if you do not wish to continue, otherwise
                  .PAUSE press any other key to proceed.

            The system will present the above on the screen with a border and
            the name of the option chosen at the top of the screen.  A pause
            message also appears automatically at the foot.  Pressing Esc will
            return to the menu while any other key will continue execution of
            the chosen routine.

      *     .INPUT - This command causes the system to request the input of a
            string of up to 50 characters from the user.  Any text appearing
            on the line after the command will be output as a prompt.

            The user enters his answer and it will be carried as a parameter
            to the batch file.  The first input line will become %1 the second
            %2 and so on.  Note the use of .SELECT, see below, which also
            allows user input.  The two methods may be mixed in an action list
            and are allocated to the parameters as they appear.

      *     .SELECT - This command is followed by a list of up to 10
            alternatives from which the user can select his answer. Each
            alternative is separated by two /s.

            When encountered PROmenu will display the options as a list and a
            highlight will appear over the first.  The highlight can be moved
            using the left and right arrow keys.   Pressing return uses the
            alternative shown as the user entry.  This will be allocated to
            the next parameter for the batch file.  eg:

                  .PRINT This routine will allow you to rename a file.
                  .PRINT Please select the drive on which the file resides.
                  .SELECT A://B://C://D://E://F:
                  .INPUT Enter existing name of file.
                  .INPUT Enter new name for file.
                  Rename %1%2 %3

            %1%2 will become say C:test, if that is what was entered and %3
            the new name for the file.

            The alternatives can be of any length, but all must appear on one
            line. eg

                  .PRINT Enter the name of the company you would like to
                  .PRINT operate on:
                  .SELECT Anycompany Limited//Another Limited//The Last One

            The batch file could then test the parameter by doing a string
            compare and act accordingly.

      *     .MENU - This command allows you to load another menu structure
            without unloading the program.  It is followed by the command line
            option /M:menuname to define the menu structure you wish to
            call.  Two other command line options are allowed:


PROmenu - Evaluation manual - Jupiter Software 1994                    Page 31

                  /S:99 Disply menu number 99 (1 to 10) on loading the
                        structure.

                  /I:9  Place highlight bar over item 9 (1 to 9) on displaying
                        the menu.

            All other variable options are transferred from the existing menu,
            ie batch file name and text attributes.

      *     .BACK - This command operates in exactly the same way as MENU and
            can have the same command line options.  However, it is used
            instead of MENU to inform the system that you are moving back up a
            hierarchical menu structure, and can be activated by the ESC key.

            When running PROmenu, if you press the ESC key the system will
            scan the action lines looking for a BACK command, and execute the
            menu option in which it appears thereby transfering control back
            to a previous menu structure.  The rules are as follows:

            1)    Look through action lines of currently displayed menu, if
                  not found

            2)    Scan action lines starting from menu 1 item 1 and pick up
                  first instance of a BACK command.

            If no BACK command is found the system acts as though F10 had been
            pressed.

            By using this approach it is possible to create a number of entry
            and exit points for each menu.

            A simple case, and the one which will be most common, is to be
            found in the on-line tutor.  Option 5 of menu 1 passes control to
            the DOS utilities menu structure with:

                  .MENU /M:DOS

            The DOS.PRO menu is loaded and menu 1 presented.  Option 5 of menu
            1 of this structure has a line which reads:

                  .BACK /M:TUTOR /S:1 /I:5

            If this option is selected the TUTOR.PRO file be loaded and menu 1
            displayed with option 5 highlighted, ie the option which was used
            to call the sub-menu. Further, as this is the only BACK command
            which appears in the structure, pressing ESC with any menu
            displayed will effect a return to the TUTOR menu.


PROmenu - Evaluation manual - Jupiter Software 1994                    Page 32

11    NETWORKS AND ENVIRONMENT VARIABLES

      If you are using PROmenu on a network each user must generate a unique
      batch file. You may store the menu programs, and general menus, in one
      public directory have the user generated batch file in private
      directories for each user. You may alternatively have all user generated
      batch files stored in the same directory but give them unique names so
      that they are still there when the routine called by PROmenu has
      finished and the file is needed again to return to PROmenu.

      USING DIFFERENT DIRECTORIES

      On the network each user is normally allocated a directory which is his
      personal area and is not used by anyone else. To make use of this for
      the user generated batch files proceed as follows:

            Create a directory called MENU on the file server, lets assume that
            drive used is E:, and install PROmenu in this.

            Create a batch file in the user's directory called MENU.BAT
            containing the following:

                  E:\MENU\PROMENU %1 %2 %3 %4 %5 %6
                  DOSMENU

      To run the menu system for each user, make the user's directory the
      default and run the menu batch file with a command line option to tell
      the system which menu data file to use:

                  MENU /M:E:\MENU\filename

      That is all that's required, no entry is needed in the PATH command for
      the use of PROmenu. The system will invoke PROmenu, generate the file
      DOSMENU.BAT in the user's directory and run it. When the application is
      finished DOS will know to return to the user's batch file and PROmenu
      will be called again.

      USING ENVIRONMENT VARIABLES

      As an alternative to the above it is possible to run the programs from a
      public diectory, say E:MENU, and to give each user a unique
      run-time file by using the U command line option.

      This can be used in conjunction with environment variables to make the
      system very simple to set up.

      Assuming that your network sets an environment variable for each user
      called USER and this is unique, proceed as follows:

            Create a directory called MENU on the file server, lets assume that
            drive used is E:, and install PROmenu in this.

            Make sure that the USER variable is created by your network.  If
            not, create it by adding the line:

                        SET USER=UserName

            where UserName is a unique identification for each user.

            Create the calling batch file using the environment variable to

PROmenu - Evaluation manual - Jupiter Software 1994                    Page 33

            call the user batch file:

                         PROMENU %1 %2 %3 %4 %5 %6
                         %USER%

            Invoke PROmenu with the command:

                         MENU /U:%USER%

      PROmenu will then create and run a unique run-time batch file for each
      user based on his ID. No other action is required.

      A further refinement would be to place the user batch file in the users
      personal directory.  This would be achieved using either multiple
      environment variables or the same one more than once.  Assume each user
      has a sub-directory based on his ID, which is in a directory called USER
      on E:.  The MENU.BAT file would contain:

                         PROMENU %1 %2 %3 %4 %5 %6 %7
                         E:\USER\%USER%\%USER%

      and would be called with:

                         MENU /U:E:\USER\%USER%\%USER%

      If a users ID was FRED, the batch file generated and run would be
      called:

                         E:\USER\FRED\FRED.BAT

      Environment variables may also be used to define the path and name of
      the menu file eg /M:%MENUFILE% and, of course, they may be used in the
      action lines entered to run the application, thereby passing the user ID
      etc, to the program to be run.

We trust that you find the programs useful and flexible enough to meet all your
menu generation requirements and look forward to receiving your registration.
However, if you have any ideas on how the features available could be improved,
we would be pleased to hear from you.




